from utils import performance
import zero
import torch
import numpy as np
from tqdm import tqdm
def apply_model(model, x_num, x_cat=None):
    return model(x_num, x_cat)

sigmoid = torch.nn.Sigmoid()

def train(epoch, model, optimizer, train_loader, loss_fn, device):
    model.train()
    loss_train = 0
    for iteration, batch_idx in tqdm(enumerate(train_loader)):
        model.train()
        optimizer.zero_grad()
        x_nums = batch_idx[1].to(device)
        x_cats = batch_idx[0].to(device)
        y_batch = batch_idx[2].float().to(device)
        
        output = sigmoid(model(x_cats, x_nums).view_as(y_batch))
        loss = loss_fn(output, y_batch)
        loss.backward()
        optimizer.step()
       
        loss_train += loss.item()
    loss_train = loss_train/len(train_loader)
    print(f'Epoch {epoch:03d} | Training loss: {loss_train:.4f}')
    return loss_train

def val(epoch, model,val_loader, loss_fn, device):
    model.eval()
    loss_val = 0
    for iteration, batch_idx in enumerate(val_loader):
        x_nums = batch_idx[1].to(device)
        x_cats = batch_idx[0].to(device)
        y_batch = batch_idx[2].float().to(device)
        output = sigmoid(model(x_cats, x_nums).view_as(y_batch))
        
        loss = loss_fn(output, y_batch)
        loss_val += loss.item()
    loss_val = loss_val/len(val_loader)
    print(f'Epoch {epoch:03d} | Validation loss: {loss_val:.4f}')
    return loss_val

def test(epoch, model, test_loader, loss_fn, device):
    model.eval()
    loss_val = 0
    prediction = []
    lebels = []
    for iteration, batch_idx in enumerate(test_loader):
        x_nums = batch_idx[1].to(device)
        x_cats = batch_idx[0].to(device)
        y_batch = batch_idx[2].float().to(device)
        output = sigmoid(model(x_cats, x_nums).view_as(y_batch))
        prediction += output.detach().cpu().numpy().tolist()
        lebels += y_batch.detach().cpu().numpy().tolist()
    
    
    # np.save(f'./output/probs.npy', prediction)
    # np.save(f'./output/labels.npy', lebels)

    roc_auc, pr_auc, acc, ba, mcc, sensitivity, specificity, precision, f1, ck = performance(lebels, prediction, thresold=0.5)
    
    test_performace = [roc_auc, pr_auc, acc, ba, mcc, sensitivity, specificity, precision, f1, ck]
    return test_performace 